#version 400 core
out vec4 FragColor;

struct DirectionalLight
{
	vec3 color;
	vec3 direction;
};

struct Material
{
  vec3 coefficients; // x = ambient, y = diffuse, z = specular
  float alpha;
};

in vec2 Texture_CS_in;
in vec3 Position_CS_in;
in vec3 Normal_CS_in;

uniform DirectionalLight directionalLight;
uniform Material material;
uniform vec3 cameraPosition;
uniform sampler2D texture_diffuse1;

vec3 getIllumination(vec3 L, vec3 N, vec3 R, vec3 V, vec3 lightColor, float attenuation)
{
	float ambient = material.coefficients.x;
	float diffuse = material.coefficients.y * max(dot(L, N), 0.0);
	float specular = material.coefficients.z * pow(max(dot(R, V), 0.0), material.alpha);
	return (diffuse + specular) * lightColor * attenuation;
}

void main()
{    
	/*
	vec3 N = normalize(Normal_CS_in);
	vec3 V = normalize(cameraPosition - Position_CS_in);

	vec3 result = material.coefficients.x * vec3(1.0);

	vec3 L = normalize(-directionalLight.direction);
    vec3 R = reflect(-L, N);
    result += getIllumination(L, N, R, V, directionalLight.color, 1.0);

	vec4 color = texture(texture_diffuse1, Texture_CS_in);
    FragColor = vec4(result * color.xyz, 1.0);
	*/
	FragColor = texture(texture_diffuse1, Texture_CS_in);
}