#version 330 core
out vec4 FragColor;

in vec2 textureCoordinate0;

uniform vec2 offsets[9];
uniform int edge_kernel[9];

uniform sampler2D celTexture;
uniform sampler2D normalTexture;

void main()
{
    vec4 color = vec4(0.0f);
    vec3 sample[9];

    for(int i = 0; i < 9; i++)
    {
        sample[i] = vec3(texture(normalTexture, textureCoordinate0 + offsets[i]));
    }

    for(int i = 0; i < 9; i++)
    {
        color += vec4(sample[i] * edge_kernel[i], 0.0f);
    }

    float greyValue = 0.3 * color.r + 0.59 * color.g + 0.11 * color.b;
    if (greyValue > 0.5)
    {
        FragColor = vec4(0.0, 0.0, 0.0, 1.0);
    }
    else
    {
        FragColor = texture(celTexture, textureCoordinate0);
    }

    //vec4 c = texture(celTexture, textureCoordinate0);
    //vec4 n = texture(normalTexture, textureCoordinate0);
    //FragColor = mix(c, n, 0.5);
    //FragColor = c;
} 